<bugID>946190<Summary>Can't catch onWidgetAfterDOMChange notification</Summary><Description>(I'm not sure if this is specific to my OS, as I've only tested in Windows 7, so I'm leaving that info as is for now)

During my debugging, I set up a dummy listener to be registered for CustomizableUI notifications. The dummy listener successfully catches the  onWidgetBeforeDOMChange notifications, but it doesn't catch any  onWidgetAfterDOMChange notification. Not when unregisterArea (with its subsequent onWidgetRemoved calls) is called, or when the widgets are first added my add-on's custom toolbar either.

I noticed that the code removeChild()'s, appendChild()'s or insertBefore()'s between those points, without keeping reference to the new nodes. It is my understanding that these methods kill the previous references, so you have to do something like "widgetNode = parent.removeChild(widgetNode)" to keep the reference, maybe that's what's keeping the onWidgetAfterDOMChange notification from firing, since it doesn't have the widgetNode reference after it's been moved?

Possibly related: I'm trying to fix a couple of remaining bugs in my add-on, after migrating to Australis code. One of the bugs happens when calling unregisterArea to remove the toolbar node, it doesn't send the widget nodes in it into the palette, instead it destroys the nodes completely.

It seems it expects the nodes to be re-created in the palette when entering customize mode after that; I think this is another situation that should be considered for bug 944887, even though the same "you can clean up before you call unregisterArea" solution applies here. But could this issue be related with not catching the notification? At least it seems to me that there is some case when the widgets would be moved to the palette, but apparently that is not being triggered because gPalette.has(aWidgetId) is true. When would this return false?</Description></bugID>